TestCase subclass: #PrologTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Tests'!

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 09:52'!
testDatabase

	{
		'Family new :? purgeDatabase(brother()).' 
			-> nil.
		'Family new :? database(brother())' 
			-> #(()).
		'Family new :? assertz(brother(''John'', ''Stewart'')),
					asserta(brother(''John'', ''Barbara'')), assertz(brother(''John'', ''Alan'')).'
			-> #(()).
		'Family new :? brother(x,y)'
			->  #(#('John' 'Barbara') #('John' 'Stewart') #('John' 'Alan')).
		'Family new :? retract(brother(''John'', ''Stewart''))'
			-> #(()).
		'Family new :? brother(x,y)'
			->  #(#('John' 'Barbara') #('John' 'Alan')).
		'Family new :? purgeDatabase(brother()).' 
			-> #(()).
	}
	do: [:assoc | self assert: (LCompiler evaluate: assoc key) = assoc value]! !

!PrologTest methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 09:20'!
testFamily

	{
		'Family new :? father(x,y)' 
			-> #(('John' 'Mary') ('John' 'David') ('David' 'Jack') ('Arthur' 'Nancy')).
		'Family new :? grandPa(''John'',y)' 
			-> #(('Nancy') ('Jack')).
		'Family new :? father(x, ''Mary'')'
			-> #(('John')).
		'Family new :? grandPa(''John'', x), father(y, x)'
			->  #(('Nancy' 'Arthur') ('Jack' 'David')).
		'Family new :? father(''John'', ''Mary'')'
			-> #(()).
		'Family new :? health(''John'', y)'
			->  #(('John had two times of heart attacks')).
		'Family new :? consult( healthHistory(''John'', x), Doctor new)'
			->  #(('John had two times of heart attacks')).
	}
	do: [:assoc | self assert: (LCompiler evaluate: assoc key) = assoc value]! !
